=== debian/changelog ===
orthanc-wsi (3.2+dfsg-7build1) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 07 Aug 2025 08:18:43 +0200

orthanc-wsi (3.2+dfsg-7) unstable; urgency=medium

  * Relax initialization tests. Closes: #1104044

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 20:37:28 +0200

orthanc-wsi (3.2+dfsg-6) unstable; urgency=medium

  * Fix d/tests/control

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 13:09:46 +0200

orthanc-wsi (3.2+dfsg-5) unstable; urgency=medium

  * Increased verbosity of "run-dicom-image-transcode-test"

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 27 Apr 2025 12:15:25 +0200

orthanc-wsi (3.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * d/t/control: tests depend on curl.
  * d/control: depend on dcmtk >= 3.6.9-5.
    dcmtk 3.6.9-5 resolved #1098944 by making the data directory
    unversioned again, but decoupling the two packages must occur at or
    after dcmtk 3.6.9-5, otherwise the newer orthanc will fail to start
    against the slightly older dcmtk package.
  * d/{,t/}control: depend on orthanc >= 1.12.7+dfsg-2.
    The orthanc version needs to be new enough to have built against a
    dcmtk version that reverted versioned dcmtk data directory.

 -- Étienne Mollier <emollier@debian.org>  Wed, 23 Apr 2025 21:05:33 +0200

orthanc-wsi (3.2+dfsg-3) unstable; urgency=medium

  [ Étienne Mollier ]
  * Fix "d/tests/run-dicom-image-transcode-test" that stopped on error.

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 22 Apr 2025 22:50:58 +0200

orthanc-wsi (3.2+dfsg-2) unstable; urgency=medium

  * Fix "d/tests/run-dicom-image-transcode-test" that was not waiting
    for the orthanc service to be in a healthy state.
  * Added Build-Depends on dcmtk-data >= 3.6.9-5. Closes: #1103505

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 22 Apr 2025 11:00:13 +0200

orthanc-wsi (3.2+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Tue, 08 Apr 2025 17:21:38 +0200

orthanc-wsi (3.1+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Mon, 17 Mar 2025 18:01:01 +0100
