## orthanc-wsi 3.3%2Bdfsg

=== Applications/CMakeLists.txt ===
--- 
+++ 
@@ -67,7 +67,8 @@
     include(FindDCMTK)
     link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp crypto)
   endif()
-  
+
+  add_definitions(-DORTHANC_ENABLE_DCMTK=1)
   link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
   
 else()
