## orthanc-wsi 3.3+dfsg

=== ViewerPlugin/CMakeLists.txt ===
--- 
+++ 
@@ -32,15 +32,11 @@
 # Generic parameters
 SET(STATIC_BUILD OFF CACHE BOOL "Static build of the third-party libraries (necessary for Windows)")
 SET(ALLOW_DOWNLOADS OFF CACHE BOOL "Allow CMake to download packages")
+SET(STANDALONE_BUILD ON CACHE BOOL "Standalone build (all the resources are embedded, necessary for releases)")
 
 # Advanced parameters to fine-tune linking against system libraries
 SET(USE_SYSTEM_OPENJPEG ON CACHE BOOL "Use the system version of OpenJpeg")
 SET(USE_SYSTEM_ORTHANC_SDK ON CACHE BOOL "Use the system version of the Orthanc plugin SDK")
-
-# Parameters related to OpenLayers
-SET(USE_SYSTEM_OPENLAYERS OFF CACHE BOOL "Use the system version of OpenLayers")
-SET(OPENLAYERS_CSS "" CACHE FILEPATH "Path to the system version of OpenLayers CSS")
-SET(OPENLAYERS_JS "" CACHE FILEPATH "Path to the system version of OpenLayers JavaScript")
 
 
 #####################################################################
@@ -70,7 +66,8 @@
     include(FindDCMTK)
     link_libraries(${Boost_LIBRARIES} ${DCMTK_LIBRARIES} jsoncpp)
   endif()
-  
+
+  add_definitions(-DORTHANC_ENABLE_DCMTK=1)
   link_libraries(${ORTHANC_FRAMEWORK_LIBRARIES})
   
 else()
@@ -146,40 +143,28 @@
 
 
 #####################################################################
-## Prepare OpenLayers
-#####################################################################
-
-if (STATIC_BUILD OR NOT USE_SYSTEM_OPENLAYERS)
-  DownloadPackage(
-    "e15da1e1f803e69a8ca1e0ed11f0cf24"
-    "https://orthanc.uclouvain.be/downloads/third-party-downloads/WSI/openlayers-10.4.0-package.tar.gz"
-    "openlayers-10.4.0-package")
-  
-  set(OPENLAYERS_RESOURCES
-    OPENLAYERS_CSS  ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/ol.css
-    OPENLAYERS_JS   ${CMAKE_CURRENT_BINARY_DIR}/openlayers-10.4.0-package/dist/ol.js
+## Prepare JavaScript libraries
+#####################################################################
+
+include(${CMAKE_SOURCE_DIR}/../Resources/CMake/JavaScriptLibraries.cmake)
+
+if (STANDALONE_BUILD)
+  add_definitions(-DORTHANC_STANDALONE=1)
+  set(VIEWER_RESOURCES
+    VIEWER_HTML          ${CMAKE_SOURCE_DIR}/viewer.html
+    VIEWER_JS            ${CMAKE_SOURCE_DIR}/viewer.js
     )
-
 else()
-  if (OPENLAYERS_CSS STREQUAL "")
-    message(FATAL_ERROR "The option OPENLAYERS_CSS is not set")
-  endif()
-
-  if (OPENLAYERS_JS STREQUAL "")
-    message(FATAL_ERROR "The option OPENLAYERS_JS is not set")
-  endif()
-
-  set(OPENLAYERS_RESOURCES
-    OPENLAYERS_CSS  ${OPENLAYERS_CSS}
-    OPENLAYERS_JS   ${OPENLAYERS_JS}
-    )  
+  add_definitions(
+    -DORTHANC_STANDALONE=0
+    -DPLUGIN_SOURCE_DIR="${CMAKE_SOURCE_DIR}"
+    )
 endif()
 
 EmbedResources(
-  ${OPENLAYERS_RESOURCES}
+  ${VIEWER_RESOURCES}
+  JAVASCRIPT_LIBS      ${JAVASCRIPT_LIBS_DIR}
   ORTHANC_EXPLORER     ${CMAKE_SOURCE_DIR}/OrthancExplorer.js
-  VIEWER_HTML          ${CMAKE_SOURCE_DIR}/viewer.html
-  VIEWER_JS            ${CMAKE_SOURCE_DIR}/viewer.js
   MIRADOR_HTML         ${CMAKE_SOURCE_DIR}/mirador.html
   OPEN_SEADRAGON_HTML  ${CMAKE_SOURCE_DIR}/openseadragon.html
   )
