=== debian/changelog ===
orthanc-wsi (3.3+dfsg-1) unstable; urgency=medium

  * New upstream version

 -- Sebastien Jodogne <s.jodogne@gmail.com>  Sun, 09 Nov 2025 20:51:26 +0100
