=== debian/rules ===
--- 
+++ 
@@ -16,21 +16,11 @@
 
 ORTHANC_FRAMEWORK_LIBRARIES="boost_filesystem boost_iostreams boost_locale boost_regex boost_thread jsoncpp pugixml uuid  dcmdata ofstd jpeg png curl boost_program_options dcmjpeg dcmjpls dcmimage dl crypto z"
 
-CMAKE_APPLICATIONS_EXTRA_FLAGS += \
+CMAKE_EXTRA_FLAGS += \
 	-DCMAKE_SKIP_RPATH:BOOL=ON \
 	-DORTHANC_FRAMEWORK_SOURCE=system \
         -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
         -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
-	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
-
-CMAKE_VIEWER_EXTRA_FLAGS += \
-	-DCMAKE_SKIP_RPATH:BOOL=ON \
-	-DORTHANC_FRAMEWORK_SOURCE=system \
-        -DORTHANC_FRAMEWORK_USE_SHARED:BOOL=OFF \
-        -DORTHANC_FRAMEWORK_ADDITIONAL_LIBRARIES=${ORTHANC_FRAMEWORK_LIBRARIES} \
-	-DUSE_SYSTEM_OPENLAYERS:BOOL=ON \
-	-DOPENLAYERS_CSS=$(CURDIR)/BuildViewer/ol.css \
-	-DOPENLAYERS_JS=$(CURDIR)/BuildViewer/ol.js \
 	-DCMAKE_BUILD_TYPE=None   # The build type must be set to None, see #711515
 
 # Automated generation of the "Built-Using" attribute in "d/control"
@@ -51,17 +41,12 @@
 	mkdir BuildApplications
 	dh_auto_configure --builddirectory=BuildApplications \
 			  --sourcedirectory=Applications \
-			  -- $(CMAKE_APPLICATIONS_EXTRA_FLAGS)
-
-        # Copy OpenLayers distribution where expected by the build scripts
-	mkdir BuildViewer
-	cp debian/missing-sources/openlayers-10.4.0-package/dist/ol.js BuildViewer/ol.js
-	cp debian/missing-sources/openlayers-10.4.0-package/ol.css BuildViewer/ol.css
+			  -- $(CMAKE_EXTRA_FLAGS)
 
         # Configure the Web viewer plugin
 	dh_auto_configure --builddirectory=BuildViewer \
 			  --sourcedirectory=ViewerPlugin \
-			  -- $(CMAKE_VIEWER_EXTRA_FLAGS)
+			  -- $(CMAKE_EXTRA_FLAGS)
 
 override_dh_clean:
 	dh_clean BuildApplications/
