=== debian/tests/control ===
Tests: run-generate-dataset-test, run-dicom-image-transcode-test
Depends: orthanc (>= 1.12.7+dfsg-2), orthanc-wsi, curl, procps
Restrictions: needs-sudo, allow-stderr
